(* Title: Knowledge/eqsystem-2.sml
   author: Walther Neuper 050826,
   (c) due to copyright terms
*)
"-----------------------------------------------------------------------------------------------";
"table of contents -----------------------------------------------------------------------------";
"-----------------------------------------------------------------------------------------------";
"----------- occur_exactly_in ---------------------------------------------------equsystem-1.sml";
"----------- problems -----------------------------------------------------------equsystem-1.sml";
"----------- rewrite-order ord_simplify_System ----------------------------------equsystem-1.sml";
"----------- rewrite in [EqSystem,normalise,2x2] --------------------------------equsystem-1.sml";
"----------- rewrite example from 2nd [EqSystem,normalise,2x2] ------------------equsystem-1.sml";
"----------- rewrite in [EqSystem,top_down_substitution,2x2] --------------------equsystem-1.sml";
"----------- rewrite in [EqSystem,normalise,4x4] --------------------------------equsystem-1.sml";
"----------- script [EqSystem,top_down_substitution,2x2] Vers.1 -----------------equsystem-1.sml";
"----------- refine [linear,system]----------------------------------------------equsystem-1.sml";
"----------- refine [2x2,linear,system] search error-----------------------------equsystem-1.sml";
"----------- me [EqSystem,normalise,2x2], refine Subproblem ---------------------equsystem-1.sml";
"----------- me [EqSystem,normalise,2x2], refine Subproblem, step into istate---equsystem-1a.sml";
"----------- me [linear,system] ..normalise..top_down_sub..----------------------equsystem-2.sml";
"----------- all systems from Biegelinie ----------------------------------------equsystem-2.sml";
"----------- 4x4 systems from Biegelinie ----------------------------------------equsystem-2.sml";
"-----------------------------------------------------------------------------------------------";
"-----------------------------------------------------------------------------------------------";
"-----------------------------------------------------------------------------------------------";

val thy = @{theory "EqSystem"};
val ctxt = Proof_Context.init_global thy;

"----------- me [linear,system] ..normalise..top_down_sub..-------";
"----------- me [linear,system] ..normalise..top_down_sub..-------";
"----------- me [linear,system] ..normalise..top_down_sub..-------";
val fmz = 
    ["equalities\
     \[0 = c_2 + c * 0 + 1 / EI * (L * q_0 / 12 * 0 \<up> 3 +                \
     \                                            - 1 * q_0 / 24 * 0 \<up> 4),\
     \ 0 = c_2 + c * L + 1 / EI * (L * q_0 / 12 * L \<up> 3 +                \
     \                                            - 1 * q_0 / 24 * L \<up> 4)]",
     "solveForVars [c, c_2]", "solution LL"];
val (dI',pI',mI') =
  ("Biegelinie",["LINEAR", "system"], ["no_met"]);
val p = e_pos'; val c = []; 
val (p,_,f,nxt,_,pt) = Test_Code.init_calc @{context} [(fmz, (dI',pI',mI'))];
val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;
case nxt of (Specify_Method ["EqSystem", "normalise", "2x2"]) => ()
	  | _ => error "eqsystem.sml [linear,system] specify b";
val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;f2str f;
val (p,_,f,nxt,_,pt) = me nxt p c pt;f2str f;
val (p,_,f,nxt,_,pt) = me nxt p c pt;f2str f;
val (p,_,f,nxt,_,pt) = me nxt p c pt;f2str f;
val (p,_,f,nxt,_,pt) = me nxt p c pt;f2str f;
if f2str f =(*BEFORE "eliminate ThmC.numerals_to_Free"..
  "[c_2 = 0, L * c + c_2 = - 1 * q_0 * L \<up> 4 / (24 * EI)]"*)
  "[c_2 = 0, L * c + c_2 = - 1 * q_0 * L \<up> 4 / 24]"
then () else error "eqsystem.sml me simpl. before SubProblem b";
case nxt of
    (Subproblem ("Biegelinie", ["triangular", "2x2", "LINEAR",_])) => ()
  | _ => error "eqsystem.sml me [linear,system] SubProblem b";

val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;
case nxt of
    (Specify_Method ["EqSystem", "top_down_substitution", "2x2"]) => ()
  | _ => error "eqsystem.sml me [EqSys...2x2] top_down_substitution b";

val (p,_,f,nxt,_,pt) = me nxt p c pt;
val PblObj {probl,...} = get_obj I pt [5];
    (writeln o (I_Model.to_string (Proof_Context.init_global @{theory Isac_Knowledge}))) probl;
(*[
(1 ,[1] ,true ,#Given ,Cor equalities [c_2 = 0, L * c + c_2 = q_0 * L \<up> 2 / 2] ,(es_, [[c_2 = 0, L * c + c_2 = q_0 * L \<up> 2 / 2]])),
(2 ,[1] ,true ,#Given ,Cor solveForVars [c, c_2] ,(v_s, [[c, c_2]])),
(3 ,[1] ,true ,#Find ,Cor solution ss___ ,(ss___, [ss___]))]
*)
val (p,_,f,nxt,_,pt) = me nxt p c pt;f2str f;
val (p,_,f,nxt,_,pt) = me nxt p c pt;f2str f;
val (p,_,f,nxt,_,pt) = me nxt p c pt;f2str f;
val (p,_,f,nxt,_,pt) = me nxt p c pt;f2str f;
val (p,_,f,nxt,_,pt) = me nxt p c pt;f2str f;
val (p,_,f,nxt,_,pt) = me nxt p c pt;f2str f;
val (p,_,f,nxt,_,pt) = me nxt p c pt;f2str f;
val (p,_,f,nxt,_,pt) = me nxt p c pt;f2str f;
case nxt of
    (Check_Postcond ["triangular", "2x2", "LINEAR", "system"]) => ()
  | _ => error "eqsystem.sml me Subpbl .[EqSys...2x2] finished b";
val (p,_,f,nxt,_,pt) = me nxt p c pt;f2str f;
val (p,_,f,nxt,_,pt) = me nxt p c pt;f2str f;

if f2str f =(*BEFORE "eliminate ThmC.numerals_to_Free"..
  "[c = - 1 * q_0 * L \<up> 3 / (24 * EI), c_2 = 0]"*)
  "[c = - 1 * q_0 * L \<up> 3 / 24, c_2 = 0]"
then () else error "eqsystem.sml me [EqSys...2x2] finished f2str f b";
case nxt of
    (End_Proof') => ()
  | _ => error "eqsystem.sml me [EqSys...2x2] finished End_Proof'";


"----------- all systems from Biegelinie -------------------------";
"----------- all systems from Biegelinie -------------------------";
"----------- all systems from Biegelinie -------------------------";
val thy = @{theory Isac_Knowledge}
val subst = 
  [(TermC.parse_test @{context} "bdv_1", TermC.parse_test @{context} "c"), (TermC.parse_test @{context} "bdv_2", TermC.parse_test @{context} "c_2"),
	(TermC.parse_test @{context} "bdv_3", TermC.parse_test @{context} "c_3"), (TermC.parse_test @{context} "bdv_4", TermC.parse_test @{context} "c_4")]; 

"------- Bsp 7.27";
States.reset ();
CalcTree @{context} [(
  ["Traegerlaenge L", "Streckenlast q_0", "Biegelinie y",
	  "Randbedingungen [y 0 = (0::real), y L = 0, M_b 0 = 0, M_b L = 0]", "FunktionsVariable x"],
	("Biegelinie", ["Biegelinien"], ["IntegrierenUndKonstanteBestimmen2"]))];
moveActiveRoot 1;
(*
LItool.trace_on := true; autoCalculate 1 CompleteCalc; LItool.trace_on := false;
##7.27##          ordered           substs
          c_4       c_2           
c c_2 c_3 c_4     c c_2             1->2: c
  c_2                       c_4	  
c c_2             c c_2 c_3 c_4     [2':c, 1:c_2, 3:c_4] -> 4:c_3*)
val t = TermC.parse_test @{context}
  ("[0 = c_4, " ^
  "0 = c_4 + L * c_3 +(12 * L \<up> 2 * c_2 + 4 * L \<up> 3 * c + - 1 * L \<up> 4 * q_0) / (- 24 * EI), " ^
  "0 = c_2, " ^
  "0 = (2 * c_2 + 2 * L * c + - 1 * L \<up> 2 * q_0) / 2]");
val SOME (t, _) = rewrite_set_ ctxt false isolate_bdvs_4x4 t;
if UnparseC.term t =
"[c_4 = 0,\n (12 * L \<up> 2 * c_2 + 4 * L \<up> 3 * c + - 1 * L \<up> 4 * q_0) /\n (- 24 * EI) =\n - 1 * (c_4 + L * c_3) + 0,\n c_2 = 0, (2 * c_2 + 2 * L * c + - 1 * L \<up> 2 * q_0) / 2 = 0]"
then () else error "Bsp 7.27";

"----- Bsp 7.27 go through the rewrites in met_eqsys_norm_4x4";
val t = TermC.parse_test @{context} "0 = (2 * c_2 + 2 * L * c + - 1 * L \<up> 2 * q_0) / 2";
val NONE = rewrite_set_ ctxt false norm_Rational t;
val SOME (t,_) = 
    rewrite_set_inst_ ctxt false subst simplify_System_parenthesized t;
if UnparseC.term t = "0 = - 1 * q_0 * L \<up> 2 / 2 + (L * c + c_2)"
then () else error "Bsp 7.27 go through the rewrites in met_eqsys_norm_4x4";

"--- isolate_bdvs_4x4";
(*
val SOME (t,_) = rewrite_set_inst_ ctxt false subst isolate_bdvs_4x4 t;
UnparseC.term t;
val SOME (t,_) = rewrite_set_inst_ ctxt false subst simplify_System t;
UnparseC.term t;
val SOME (t,_) = rewrite_set_ ctxt false order_system t;
UnparseC.term t;
*)

"------- Bsp 7.28 ---------------vvvvvvvvvvvvv Momentenlinie postponed";
States.reset ();
CalcTree @{context} [((*WN130908  <ERROR> error in kernel </ERROR>*)
  ["Traegerlaenge L", "Momentenlinie (-q_0 / L * x \<up> 3 / 6)",
	    "Biegelinie y",
	    "Randbedingungen [y L = 0, y' L = 0]",
	    "FunktionsVariable x"],
	   ("Biegelinie", ["vonMomentenlinieZu", "Biegelinien"],
	    ["Biegelinien", "AusMomentenlinie"]))];
(*
moveActiveRoot 1;
LItool.trace_on := true; autoCalculate 1 CompleteCalc; LItool.trace_on := false;
*)

"------- Bsp 7.69";
States.reset ();
CalcTree @{context} [(
  ["Traegerlaenge L", "Streckenlast q_0", "Biegelinie y",
	  "Randbedingungen [y 0 = (0::real), y L = 0, y' 0 = 0, y' L = 0]", "FunktionsVariable x"],
	("Biegelinie", ["Biegelinien"], ["IntegrierenUndKonstanteBestimmen2"]))];
moveActiveRoot 1;
(*
LItool.trace_on := true; autoCalculate 1 CompleteCalc; LItool.trace_on := false;
##7.69##          ordered           subst                   2x2
          c_4           c_3         
c c_2 c_3 c_4     c c_2 c_3	    1:c_3 -> 2:c c_2        2:         c c_2
      c_3                   c_4	 			   
c c_2 c_3         c c_2 c_3 c_4     3:c_4 -> 4:c c_2 c_3    1:c_3 -> 4:c c_2*)
val t = TermC.parse_test @{context} 
  ("[0 = c_4 + 0 / (- 1 * EI), " ^
  "0 = c_4 + L * c_3 + (12 * L \<up> 2 * c_2 + 4 * L \<up> 3 * c + - 1 * L \<up> 4 * q_0) / (- 24 * EI), " ^
  "0 = c_3 + 0 / (- 1 * EI), " ^
  "0 = c_3 + (6 * L * c_2 + 3 * L \<up> 2 * c + - 1 * L \<up> 3 * q_0) / (-6 * EI)]");

"------- Bsp 7.70";
States.reset ();
CalcTree @{context} [(
  ["Traegerlaenge L", "Streckenlast q_0", "Biegelinie y",
	  "Randbedingungen [Q 0 = q_0 * L, M_b L = 0, y 0 = (0::real), y' 0 = 0]", "FunktionsVariable x"],
	("Biegelinie", ["Biegelinien"], ["IntegrierenUndKonstanteBestimmen2"] ))];
moveActiveRoot 1;
(*
LItool.trace_on := true; autoCalculate 1 CompleteCalc; LItool.trace_on := false;
##7.70##        |subst
c		|
c c_2           |1:c -> 2:c_2
      c_3	|
          c_4   |            STOPPED.WN06? test methods @@@@@@@@@@@@@@@@@@@@@@@*)

"----- 7.70 go through the rewrites in met_eqsys_norm_4x4";
val t = TermC.parse_test @{context}
  ("[L * q_0 = c, " ^
  "0 = (2 * c_2 + 2 * L * c + - 1 * L \<up> 2 * q_0) / 2, " ^
  "0 = c_4, " ^
  "0 = c_3]");
val SOME (t,_) = rewrite_ ctxt Rewrite_Ord.function_empty Rule_Set.empty false @{thm commute_0_equality} t;
val SOME (t,_) = rewrite_ ctxt Rewrite_Ord.function_empty Rule_Set.empty false @{thm commute_0_equality} t;
val SOME (t,_) = rewrite_ ctxt Rewrite_Ord.function_empty Rule_Set.empty false @{thm commute_0_equality} t;
if UnparseC.term t = 
  "[L * q_0 = c, (2 * c_2 + 2 * L * c + - 1 * L \<up> 2 * q_0) / 2 = 0,\n c_4 = 0, c_3 = 0]"
then () else error "7.70 go through the rewrites in met_eqsys_norm_4x4, 1";

val SOME (t,_) = rewrite_set_inst_ ctxt false subst simplify_System_parenthesized t;
if UnparseC.term t = "[L * q_0 = c, - 1 * q_0 * L \<up> 2 / 2 + (L * c + c_2) = 0, c_4 = 0,\n c_3 = 0]"
then () else error "7.70 go through the rewrites in met_eqsys_norm_4x4, 2";

val SOME (t,_) = rewrite_set_inst_ ctxt false subst isolate_bdvs_4x4 t;
if UnparseC.term t =
   "[c = (- 1 * (L * q_0) + 0) / - 1,\n" ^ 
   " L * c + c_2 = - 1 * (- 1 * q_0 * L \<up> 2 / 2) + 0, c_4 = 0, c_3 = 0]"
then () else error "7.70 go through the rewrites in met_eqsys_norm_4x4, 3";

val SOME (t,_) = rewrite_set_inst_ ctxt false subst simplify_System_parenthesized t;
if UnparseC.term t =
  "[c = - 1 * L * q_0 / - 1, L * c + c_2 = q_0 * L \<up> 2 / 2, c_4 = 0,\n c_3 = 0]"
then () else error "7.70 go through the rewrites in met_eqsys_norm_4x4, 4";

val SOME (t, _) = rewrite_set_ ctxt false order_system t;
if UnparseC.term t =
  "[c = - 1 * L * q_0 / - 1, L * c + c_2 = q_0 * L \<up> 2 / 2, c_3 = 0,\n c_4 = 0]"
then () else error "eqsystem.sml: exp 7.70 normalise 4x4 by rewrite changed";

"----- 7.70 with met normalise: ";
val fmz = ["equalities" ^
  "[L * q_0 = c, " ^
  "0 = (2 * c_2 + 2 * L * c + - 1 * L \<up> 2 * q_0) / 2, " ^
  "0 = c_4, " ^
  "0 = c_3]", "solveForVars [c, c_2, c_3, c_4]", "solution LL"];
val (dI',pI',mI') = ("Biegelinie",["LINEAR", "system"], ["no_met"]);
val p = e_pos'; val c = [];

(*============ inhibit exn WN120314 TODO: investigate type error (same as above)==
  in next but one test below the same type error.
/-------------------------------------------------------\
Type unification failed
Type error in application: incompatible operand type

Operator:  op # c_3 :: 'a list \<Rightarrow> 'a list
Operand:   [c_4] :: 'b list
\-------------------------------------------------------/

val (p,_,f,nxt,_,pt) = Test_Code.init_calc @{context} [(fmz, (dI',pI',mI'))];
val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;
case nxt of (_,Apply_Method ["EqSystem", "normalise", "4x4"]) => ()
	  | _ => error "eqsystem.sml [EqSystem,normalise,4x4] specify";
val (p,_,f,nxt,_,pt) = me nxt p c pt; f2str f;

"----- outcommented before Isabelle2002 --> 2011 -------------------------";
(*-----------------------------------vvvWN080102 Exception- Match raised 
  since associate Rewrite .. Rewrite_Set
val (p,_,f,nxt,_,pt) = me nxt p c pt; f2str f;

val (p,_,f,nxt,_,pt) = me nxt p c pt; f2str f;
val (p,_,f,nxt,_,pt) = me nxt p c pt; f2str f;

val (p,_,f,nxt,_,pt) = me nxt p c pt; f2str f;
val (p,_,f,nxt,_,pt) = me nxt p c pt; f2str f;
val (p,_,f,nxt,_,pt) = me nxt p c pt; f2str f;
val (p,_,f,nxt,_,pt) = me nxt p c pt; f2str f;
if f2str f ="[c = L * q_0, L * c + c_2 = q_0 * L \<up> 2 / 2, c_3 = 0, c_4 = 0]" 
then () else error "eqsystem.sml: exp 7.70 normalise 4x4 by met changed";
--------------------------------------------------------------------------*)
============ inhibit exn WN120314 ==============================================*)

"----- 7.70 with met top_down_: me";
val fmz = [
  "equalities [(c::real) = L * q_0, L * c + (c_2::real) = q_0 * L \<up> 2 / 2, (c_3::real) = 0, (c_4::real) = 0]",
	"solveForVars [(c::real), (c_2::real), (c_3::real), (c_4::real)]", "solution LL"];
val (dI',pI',mI') =
  ("Biegelinie",["LINEAR", "system"],["no_met"]);
val p = e_pos'; val c = []; 
val (p,_,f,nxt,_,pt) = Test_Code.init_calc @{context} [(fmz, (dI',pI',mI'))];
val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;
case nxt of Apply_Method ["EqSystem", "top_down_substitution", "4x4"] => ()
	  | _ => error "eqsystem.sml [EqSystem,top_down_,4x4] specify";
val (p,_,f,nxt,_,pt) = me nxt p c pt; f2str f;
val (p,_,f,nxt,_,pt) = me nxt p c pt; f2str f;
val (p,_,f,nxt,_,pt) = me nxt p c pt; f2str f;
val (p,_,f,nxt,_,pt) = me nxt p c pt; f2str f;
val (p,_,f,nxt,_,pt) = me nxt p c pt; f2str f;
val (p,_,f,nxt,_,pt) = me nxt p c pt; f2str f;
if p = ([], Res) andalso
(*           "[c = L * q_0, c_2 = - 1 * L \<up> 2 * q_0 / 2, c_3 = 0, c_4 = 0]"*)
   f2str f = "[c = L * q_0, c_2 = - 1 * L \<up> 2 * q_0 / 2, c_3 = 0, c_4 = 0]"
then () else error "eqsystem.sml: 7.70 with met top_down_: me";

"------- Bsp 7.71";
States.reset ();
CalcTree @{context} [(["Traegerlaenge L", "Streckenlast q_0", "Biegelinie y",
	     "Randbedingungen [M_b L = 0, y 0 = (0::real), y L = 0, y' 0 = 0]",
	     "FunktionsVariable x", "GleichungsVariablen [c, c_2, c_3, c_4]",
	     "AbleitungBiegelinie dy"],
	    ("Biegelinie", ["Biegelinien"],
	     ["IntegrierenUndKonstanteBestimmen2"] ))];
moveActiveRoot 1;
(*
LItool.trace_on := true; autoCalculate 1 CompleteCalc; LItool.trace_on := false;
##7.71##       |ordered       |subst.singles (recurs) |2x2       |diagonal
c c_2          |c c_2	      |1'		      |1': c c_2 |
          c_4  |      c_3     |2:c_3 -> 4' :c c_2 c_4 |	         |
c c_2 c_3 c_4  |          c_4 |3'                     |	         |
      c_3      |c c_2 c_3 c_4 |3:c_4 -> 4'':c c_2     |4'':c c_2 |      *)
val t = TermC.parse_test @{context}"[0 = (2 * c_2 + 2 * L * c + - 1 * L \<up> 2 * q_0) / 2, \
\ 0 = c_4 + 0 / (- 1 * EI),                            \
\ 0 = c_4 + L * c_3 +(12 * L \<up> 2 * c_2 + 4 * L \<up> 3 * c + - 1 * L \<up> 4 * q_0) /(- 24 * EI),\
\ 0 = c_3 + 0 / (- 1 * EI)]";

"------- Bsp 7.72a ---------------vvvvvvvvvvvvv Momentenlinie postponed";
States.reset ();
CalcTree @{context} [(["Traegerlaenge L",
	    "Momentenlinie ((q_0 * L)/ 6 * x - q_0 /(6 * L) * x \<up> ^3)",
	    "Biegelinie y",
	    "Randbedingungen [y 0 = (0::real), y L = 0]",
	    "FunktionsVariable x"],
	   ("Biegelinie", ["vonMomentenlinieZu", "Biegelinien"],
	    ["Biegelinien", "AusMomentenlinie"]))];
moveActiveRoot 1;
(*
LItool.trace_on := true; autoCalculate 1 CompleteCalc; LItool.trace_on := false;
*)

"------- Bsp 7.72b";
States.reset ();
CalcTree @{context} [(["Traegerlaenge L", "Streckenlast (q_0 / L * x)", "Biegelinie y",
	    "Randbedingungen [M_b 0 = 0, M_b L = 0, y 0 = (0::real), y L = 0]",
	    "FunktionsVariable x", "GleichungsVariablen [c, c_2, c_3, c_4]",
	    "AbleitungBiegelinie dy"],
	   ("Biegelinie", ["Biegelinien"],
	    ["IntegrierenUndKonstanteBestimmen2"] ))];
moveActiveRoot 1;
(*
LItool.trace_on := true; autoCalculate 1 CompleteCalc; LItool.trace_on := false;
##7.72b##      |ord. |subst.singles         |ord.triang.
  c_2          |     |			    |c_2  
c c_2	       |     |1:c_2 -> 2':c	    |c_2 c
          c_4  |     |			    |
c c_2 c_3 c_4  |     |3:c_4 -> 4':c c_2 c_3 |c_2 c c_3*)
val t = TermC.parse_test @{context}"[0 = c_2,                                            \
\ 0 = (6 * c_2 + 6 * L * c + - 1 * L \<up> 2 * q_0) / 6, \
\ 0 = c_4 + 0 / (- 1 * EI),                            \
\ 0 = c_4 + L * c_3 + (60 * L \<up> 2 * c_2 + 20 * L \<up> 3 * c + - 1 * L \<up> 4 * q_0) / (- 120 * EI)]";

"------- Bsp 7.73 ---------------vvvvvvvvvvvvv Momentenlinie postponed";
States.reset ();
CalcTree @{context} [(["Traegerlaenge L", "Momentenlinie ???",(*description unclear*)
	    "Biegelinie y",
	    "Randbedingungen [y L = 0, y' L = 0]",
	    "FunktionsVariable x"],
	   ("Biegelinie", ["vonMomentenlinieZu", "Biegelinien"],
	    ["Biegelinien", "AusMomentenlinie"]))];
moveActiveRoot 1;
(*
LItool.trace_on := true; autoCalculate 1 CompleteCalc; LItool.trace_on := false;
*)

"----------- 4x4 systems from Biegelinie -------------------------";
"----------- 4x4 systems from Biegelinie -------------------------";
"----------- 4x4 systems from Biegelinie -------------------------";
(*STOPPED.WN08?? replace this test with 7.70 *)
"----- Bsp 7.27";
val fmz = ["equalities \
	   \[0 = c_4,                           \
	   \ 0 = c_4 + L * c_3 +(12 * L \<up> 2 * c_2 + 4 * L \<up> 3 * c + - 1 * L \<up> 4 * q_0) / (- 24 * EI),                                       \
	   \ 0 = c_2,                                           \
	   \ 0 = (2 * c_2 + 2 * L * c + - 1 * L \<up> 2 * q_0) / 2]", 
	   "solveForVars [c, c_2, c_3, c_4]", "solution LL"];
val (dI',pI',mI') =
  ("Biegelinie",["normalise", "4x4", "LINEAR", "system"],
   ["EqSystem", "normalise", "4x4"]);
val p = e_pos'; val c = []; 
val (p,_,f,nxt,_,pt) = Test_Code.init_calc @{context} [(fmz, (dI',pI',mI'))];
val (p,_,f,nxt,_,pt) = me nxt p c pt; val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt; val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt; val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt; val (p,_,f,nxt,_,pt) = me nxt p c pt;
"------------------------------------------- Apply_Method...";
val (p,_,f,nxt,_,pt) = me nxt p c pt; f2str f;
"[0 = c_4,                                          \
\ 0 = c_4 + L * c_3 +\n (12 * L \<up> 2 * c_2 + 4 * L \<up> 3 * c + - 1 * L \<up> 4 * q_0) / (- 24 * EI),                                   \
\ 0 = c_2,                                          \
\ 0 = (2 * c_2 + 2 * L * c + - 1 * L \<up> 2 * q_0) / 2]";
(*vvvWN080102 Exception- Match raised 
  since associate Rewrite .. Rewrite_Set
"------------------------------------------- simplify_System_parenthesized...";
val (p,_,f,nxt,_,pt) = me nxt p c pt; f2str f;
"[0 = c_4,                                  \
\ 0 = - 1 * q_0 * L \<up> 4 / (- 24 * EI) +     \
\     (4 * L \<up> 3 * c / (- 24 * EI) +       \
\     (12 * L \<up> 2 * c_2 / (- 24 * EI) +    \
\     (L * c_3 + c_4))),                    \
\ 0 = c_2,                                  \
\ 0 = - 1 * q_0 * L \<up> 2 / 2 + (L * c + c_2)]";
(*? "(4 * L \<up> 3 / (- 24 * EI) * c" statt "(4 * L \<up> 3 * c / (- 24 * EI)" ?*)
"------------------------------------------- isolate_bdvs...";
val (p,_,f,nxt,_,pt) = me nxt p c pt; f2str f;
"[c_4 = 0,\
\ c_4 = 0 + - 1 * (- 1 * q_0 * L \<up> 4 / (- 24 * EI)) + - 1 * (4 * L \<up> 3 * c / (- 24 * EI)) + - 1 * (12 * L \<up> 2 * c_2 / (- 24 * EI)) + - 1 * (L * c_3),\
\ c_2 = 0, \
\ c_2 = 0 + - 1 * (- 1 * q_0 * L \<up> 2 / 2) + - 1 * (L * c)]";
val (p,_,f,nxt,_,pt) = me nxt p c pt; f2str f;

---------------------------------------------------------------------*)
